Star

Leetcode 325. Maximum Size Subarray Sum Equals k

Question:

Given an array nums and a target value k, find the maximum length of a subarray that sums to k. If there isn't one, return 0 instead.

Note: The sum of the entire nums array is guaranteed to fit within the 32-bit signed integer range.

Example 1: Given nums = [1, -1, 5, -2, 3], k = 3, return 4. (because the subarray [1, -1, 5, -2] sums to 3 and is the longest)

Example 2: Given nums = [-2, -1, 2, 1], k = 1, return 2. (because the subarray [-1, 2] sums to 1 and is the longest)

Follow Up: Can you do it in O(n) time?

Explanation:

思路就是,算从第一个数到每一个数的sum,存在map里,如果之后有key和sum-k相等,就表示那段数字的和为k。

Code:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
public class Solution {
public int maxSubArrayLen(int[] nums, int k) {
HashMap<Integer, Integer> map = new HashMap<>();
int sum = 0;
int result = 0;
for (int i=0; i<nums.length; i++) {
sum += nums[i];
if (sum == k) {
result = i+1;
} else if (map.containsKey(sum - k)) {
result =Math.max(max, i - map.get(sum));
}
if (!map.containsKey(sum)) {
map.put(sum, i);
}
System.out.println(map.toString());
}
return result;
}
}